package net.pingex.dcf.modularity;

import org.apache.commons.configuration2.ImmutableConfiguration;

/**
 * Basic declaration of a plugin
 */
public interface IPlugin
{
	/**
	 * Load basic parameters, instantiate some objects, load configuration
	 * @param configuration Configuration from dcf.properties
	 */
	void load(ImmutableConfiguration configuration);

	/**
	 * Power up objects, shedule tasks, and so on
	 */
	void run();

	/**
	 * Stop everything, doesn't mean we'll unload the plugin
	 */
	void stop();

	/**
	 * Unload the plugin, clean up, etc
	 */
	void unload();
}
